// This file is part of MinIO DirectPV
// Copyright (c) 2024 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

package admin

import (
	"github.com/minio/directpv/pkg/client"
	"k8s.io/client-go/rest"
)

// Client represents the admin clientset
type Client struct {
	*client.Client
}

// NewClient returns a new admin client
func NewClient(c *rest.Config) (*Client, error) {
	directpvClientSet, err := client.NewClient(c)
	if err != nil {
		return nil, err
	}
	return &Client{
		Client: directpvClientSet,
	}, nil
}
