// This file is part of MinIO DirectPV
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	http "net/http"

	directpvminiov1beta1 "github.com/minio/directpv/pkg/apis/directpv.min.io/v1beta1"
	scheme "github.com/minio/directpv/pkg/clientset/scheme"
	rest "k8s.io/client-go/rest"
)

type DirectpvV1beta1Interface interface {
	RESTClient() rest.Interface
	DirectPVDrivesGetter
	DirectPVInitRequestsGetter
	DirectPVNodesGetter
	DirectPVVolumesGetter
}

// DirectpvV1beta1Client is used to interact with features provided by the directpv.min.io group.
type DirectpvV1beta1Client struct {
	restClient rest.Interface
}

func (c *DirectpvV1beta1Client) DirectPVDrives() DirectPVDriveInterface {
	return newDirectPVDrives(c)
}

func (c *DirectpvV1beta1Client) DirectPVInitRequests() DirectPVInitRequestInterface {
	return newDirectPVInitRequests(c)
}

func (c *DirectpvV1beta1Client) DirectPVNodes() DirectPVNodeInterface {
	return newDirectPVNodes(c)
}

func (c *DirectpvV1beta1Client) DirectPVVolumes() DirectPVVolumeInterface {
	return newDirectPVVolumes(c)
}

// NewForConfig creates a new DirectpvV1beta1Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*DirectpvV1beta1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new DirectpvV1beta1Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*DirectpvV1beta1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &DirectpvV1beta1Client{client}, nil
}

// NewForConfigOrDie creates a new DirectpvV1beta1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *DirectpvV1beta1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new DirectpvV1beta1Client for the given RESTClient.
func New(c rest.Interface) *DirectpvV1beta1Client {
	return &DirectpvV1beta1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := directpvminiov1beta1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = rest.CodecFactoryForGeneratedClient(scheme.Scheme, scheme.Codecs).WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *DirectpvV1beta1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
