// This file is part of MinIO DirectPV
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	context "context"

	directpvminiov1beta1 "github.com/minio/directpv/pkg/apis/directpv.min.io/v1beta1"
	scheme "github.com/minio/directpv/pkg/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// DirectPVVolumesGetter has a method to return a DirectPVVolumeInterface.
// A group's client should implement this interface.
type DirectPVVolumesGetter interface {
	DirectPVVolumes() DirectPVVolumeInterface
}

// DirectPVVolumeInterface has methods to work with DirectPVVolume resources.
type DirectPVVolumeInterface interface {
	Create(ctx context.Context, directPVVolume *directpvminiov1beta1.DirectPVVolume, opts v1.CreateOptions) (*directpvminiov1beta1.DirectPVVolume, error)
	Update(ctx context.Context, directPVVolume *directpvminiov1beta1.DirectPVVolume, opts v1.UpdateOptions) (*directpvminiov1beta1.DirectPVVolume, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, directPVVolume *directpvminiov1beta1.DirectPVVolume, opts v1.UpdateOptions) (*directpvminiov1beta1.DirectPVVolume, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*directpvminiov1beta1.DirectPVVolume, error)
	List(ctx context.Context, opts v1.ListOptions) (*directpvminiov1beta1.DirectPVVolumeList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *directpvminiov1beta1.DirectPVVolume, err error)
	DirectPVVolumeExpansion
}

// directPVVolumes implements DirectPVVolumeInterface
type directPVVolumes struct {
	*gentype.ClientWithList[*directpvminiov1beta1.DirectPVVolume, *directpvminiov1beta1.DirectPVVolumeList]
}

// newDirectPVVolumes returns a DirectPVVolumes
func newDirectPVVolumes(c *DirectpvV1beta1Client) *directPVVolumes {
	return &directPVVolumes{
		gentype.NewClientWithList[*directpvminiov1beta1.DirectPVVolume, *directpvminiov1beta1.DirectPVVolumeList](
			"directpvvolumes",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *directpvminiov1beta1.DirectPVVolume { return &directpvminiov1beta1.DirectPVVolume{} },
			func() *directpvminiov1beta1.DirectPVVolumeList { return &directpvminiov1beta1.DirectPVVolumeList{} },
		),
	}
}
